<template>
	<input ref="inputRef" type="text" :class="thisClass" :disabled="disabled" />
</template>

<script setup lang="ts">
import { computed, watch } from "vue";
import {
	type CurrencyInputOptions,
	useCurrencyInput,
} from "vue-currency-input";

// PROPS
const props = defineProps({
	modelValue: { type: Number, default: 0 },
	options: { type: Object as () => CurrencyInputOptions, default: {} },
	class: { type: String, default: "" },
	disabled: { type: Boolean, default: false },
});

const { inputRef, setValue } = useCurrencyInput(props.options);

// #region COMPUTED
const thisClass = computed(() => {
	return props.class.split(" ");
});
// #endregion

watch(
	() => props.modelValue,
	(value: Number) => {
		setValue(value != null ? value.valueOf() : 0);
	}
);
</script>
